# FILE: setPerlMode.tcl
#
# LAST UPDATE: 01/07/93 8:37:08 AM
#
# This file contains the following TCL procedure(s):
#
#	setPerlMode -- used with changeMode & Perl programming language

# COPYRIGHT:
#
#	Copyright  1993 by David C. Black
#	All rights reserved.
#
#	Redistribution and use in source and binary forms are permitted
#	provided that the above copyright notice and this paragraph are
#	duplicated in all such forms and that any documentation,
#	advertising materials, and other materials related to such
#	distribution and use acknowledge that the software was developed
#	by David C. Black.
#
#	THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
#	IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
#	WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#
################################################################################

# Perl programming mode
proc setPerlMode {} {
	changeMode "Perl"
	uplevel #0 {
		set elecLBrace 0
		set elecRBrace 0
		set electricSemi 0
		set wordWrap 0
		set funcTitle "Sub"
		set funcExpr {^sub *([a-zA-Z0-9_]*) }
		set funcPar 1
		set sortedIsDefault 0
		set prefixString "# "
	}
}
