#
# Makefile for MPW
#

LIBS = -lc
STARTUP = crt0 sacroot
LDFLAGS=

COPTIONS = '+N' -dMACINTOSH

MACH=	mac.o malloc.o

OBJ= mac.o alloc.o fileio.o main.o normal.o regexp.o cmdline.o help.o malloc.o 
ops.o regsub.o undo.o hexchars.o mark.o screen.o linefunc.o param.o 
search.o version.o edit.o misccmds.o ptrfunc.o

all  stevie

stevie  headers.dmp {OBJ} stevie.r
	Ln '+M' {STARTUP} {OBJ} {LIBS} {LDFLAGS} -o stevie
	rez stevie.r -append -o stevie -c STvi
	SetFile -a B stevie

clean 
	rm -i {OBJ}

headers.dmp	 ascii.h env.h keymap.h ops.h param.h 
	regexp.h regmagic.h stevie.h term.h    
	cc -A {COPTIONS} stevie.h '+H' headers.dmp
	delete -i stevie.asm

.o		.c
	cc '+I' headers.dmp -A {COPTIONS} {default}.c -o {default}.asm
	as {default}.asm -o {default}.o -ZAP

main.o		main.c
	cc '+I' headers.dmp -A {COPTIONS} main.c -o main.asm -Dmain=xmain
	as main.asm -o main.o -ZAP

help.o		help.c
	cc -A {COPTIONS} help.c -o help.asm -z 10000
	as help.asm -o help.o -ZAP

